#include <stdio.h>

#include "qkd/models.h"
#include "qkd/ssl_socket_client.h"


int main(int argc, char *argv[]) {
    /* Activate/deactivate certificate availability */
    char *cert_pem = "../ssl/127.0.0.1.pem", *key_pem = "../ssl/127.0.0.1.key";
//    char *cert_pem = NULL, *key_pem = NULL;

    /* Activate/deactivate peer cert verification */
//    char *peer_ca_pem = "ssl/root_CA.pem";
    char *peer_ca_pem = NULL;
    char *host = "127.0.0.1";
    int port = 25575;

    int max_proto_version;
//    max_proto_version = TLS1_2_VERSION;
    max_proto_version = 0;

    qkd_client_context_data_t cfg = {host, port, cert_pem, key_pem, peer_ca_pem, max_proto_version};

    // --- OPEN_CONNECT ---
    char *source = "qkd//app1@aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa";
    char *destination = "qkd//app2@bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb";
    qkd_qos_t qos = {32, 32, 32, 0, 0, 0, 0, "application/json"};
    qkd_open_connect_request_t oc_request = {source, destination, qos, {}};
    uuid_parse("00000000-0000-0000-0000-000000000000", oc_request.key_stream_id);

    // qkd_open_connect() or qkd_open_connect_struct()
    qkd_open_connect_response_t oc_response = qkd_open_connect_struct(oc_request, &cfg);


    // --- GET_KEY ---
    qkd_get_key_request_t gk_request = {{}, 0, (qkd_metadata_t) {0, "[\"device_info\"]"}};
    uuid_copy(gk_request.key_stream_id, oc_response.key_stream_id);

    // qkd_get_key() or qkd_get_key_struct()
    qkd_get_key_response_t gk_response = qkd_get_key_struct(gk_request, &cfg);


    // --- CLOSE ---
    qkd_close_request_t cl_request = {.key_stream_id={}};
    uuid_copy(cl_request.key_stream_id, oc_response.key_stream_id);

    // qkd_close() or qkd_close_struct()
    qkd_close_response_t cl_response = qkd_close_struct(cl_request, &cfg);

    return 0;
}
